//Copyright Stefan Eisold & Oliver Klimpke
//Code written for Minibug
#include <avr/io.h>
#include <stdlib.h>
#define F_CPU 1200000UL  // 1,2 MHz
#include <util/delay.h>
#include "messen.h"
#include "servosensor.h"

int value;

//hindernis = {0,1,2,3} = {kein, links, mitte, rechts}
int hindernis;


void vorwaerts (int x){

	PORTD &= ~_BV(PD1);
	PORTD |= _BV(PD2);
	PORTD &= ~_BV(PD3);
	PORTD |= _BV(PD4);
	OCR1A = x;
	OCR1B = x;
}

void linksdrehen (int x){
	PORTD = 0; _delay_ms(255);
	PORTD &= ~_BV(PD2);
	PORTD |= _BV(PD1);
	PORTD &= ~_BV(PD4);
	PORTD |=  _BV(PD3);
	OCR1A = x;
	OCR1B = x;
	_delay_ms(255);

	while(value>=250){
	PORTC &= ~_BV(PC0); 
	PORTD &= ~_BV(PD1); PORTD |= _BV(PD2);
	value = MESSWERT(2);
	_delay_ms(150);
	}

	PORTC |= _BV(PC0);
}

void rechtsdrehen (int x){
	PORTD = 0; _delay_ms(255);
	PORTD &= ~_BV(PD2);
	PORTD |= _BV(PD1);
	PORTD &= ~_BV(PD4);
	PORTD |=  _BV(PD3);
	OCR1A = x;
	OCR1B = x;
	_delay_ms(255);

	while(value>=250){
	PORTC &= ~_BV(PC0);
	PORTD |= _BV(PD4); PORTD &= ~_BV(PD3);
	value = MESSWERT(2);
	_delay_ms(150);
	}

	PORTC |= _BV(PC0);
}

void mittedrehen (void){
	int j;
	j = rand();
	j = j % 2;	
	if(j==0){linksdrehen(100);}
	if(j==1){rechtsdrehen(100);}
}

void reagieren (void){
	if (hindernis==0) vorwaerts(200);
	if (hindernis==1) linksdrehen(100);
	if (hindernis==2) mittedrehen();
	if (hindernis==3) rechtsdrehen(100);

} 

void sensorlinks (void){
	links();
	value = MESSWERT(2);
	if(value>=250) {hindernis=1;PORTC &= ~_BV(PC1); reagieren();  }
	else {hindernis=0;PORTC |= _BV(PC1); reagieren();  }
}

void sensorrechts (void){
	rechts();
	value = MESSWERT(2);
	if(value>=250) {hindernis=3;PORTC &= ~_BV(PC1); reagieren();  }
	else {hindernis=0;PORTC |= _BV(PC1); reagieren();  }
}

void sensormittelinks (void){
	linksmitte();
	value = MESSWERT(2);
	if(value>=250){hindernis=2;PORTC &= ~_BV(PC1); reagieren(); }
	else {hindernis=0;PORTC |= _BV(PC1); reagieren(); }
}

void sensormitterechts (void){
	rechtsmitte();
	value = MESSWERT(2);
	if(value>=250){hindernis=2;PORTC &= ~_BV(PC1); reagieren(); }
	else {hindernis=0;PORTC |= _BV(PC1); reagieren(); }
}

int main (void){
	DDRC &= ~_BV(PC2);
	DDRC |= _BV(PC1);
	DDRC |= _BV(PC0);
	DDRB = 255;
	DDRD = 255;
	TCCR1A = (1<<COM1A1) | (1<<COM1B1) | (1<<WGM10);
	TCCR1B = _BV(CS11);	
	value=0;
	while(1) {
		sensorlinks(); sensormittelinks(); sensorrechts(); sensormitterechts();
	}
return 0;
}




